<?php

/**
 * EveryPay Payment Gateway for WooCommerce
 * https://wordpress.org/plugins/everypay-woocommerce-addon/
 *
 */
class WFACP_EveryPay {
	public function __construct() {
		add_action( 'wfacp_after_template_found', [ $this, 'template_found' ] );
	}

	public function template_found() {
		if ( wp_doing_ajax() ) {
			return;
		}
		add_filter( 'pre_option_woocommerce_checkout_page_id', [ $this, 'set_checkout_page_id' ] );
	}

	public function set_checkout_page_id() {
		return WFACP_Common::get_id();
	}
}

if ( ! function_exists( 'everypay_init' ) ) {
	return;
}
WFACP_Plugin_Compatibilities::register( new WFACP_EveryPay(), 'everypay' );
